	import java.io.BufferedWriter;
	import java.io.FileNotFoundException;
	import java.io.FileOutputStream;
	import java.io.IOException;
	import java.io.OutputStreamWriter;
	
public class fitxersortida {

		private BufferedWriter esc;
	 
		/**
		 * Crea o obre un fitxer amb la ruta donada.
		 * @param lugar Direccio relativa del fitxer.
		 * @throws FileNotFoundException Si es produeix un error al crear el nou fitxer.
		 */
		public fitxersortida(String lugar) throws FileNotFoundException{
			this.esc = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(lugar)));
		}
		/**
		 * Escriu en un fitxero donat.
		 * @param fichero L'Stream del fitxer.
		 * @throws FileNotFoundException Si no es troba el fitxer.
		 */
		public fitxersortida(FileOutputStream fichero) throws FileNotFoundException{
			this.esc = new BufferedWriter(new OutputStreamWriter(fichero));
		}
	/*-------------------------------------FUNCIONES DE LA CLASE-------------------------------------*/
	 
		/**
		 * Inserta el text.
		 * @param txt Text ha insertar.
		 * @return true Si s'escriu correctament.
		 */
		public boolean esc(String txt){
			try {
				this.esc.write(txt);
				return true;
			} catch (IOException e) {
				return false;
			}
		}
		
		public boolean escint(int txt){
			try {
				this.esc.write(txt);
				return true;
			} catch (IOException e) {
				return false;
			}
		}
		/**
		 * Inserta el text y despres un retorno de carro.
		 * @param txt Text ha insertar.
		 * @return true Si s'escriu correctament.
		 */
		public boolean escln(String txt){
			if(this.esc(txt)){
				return this.ln();
			}else{
				return false;
			}
		}
		/**
		 * Insertar un retorn de carro en el fitxer.
		 * @return true Si s'escriu correctament.
		 */
		public boolean ln(){
			try {
				this.esc.newLine();
				return true;
			} catch (IOException e) {
				return false;
			}
		}
	 
		/**
		 * Tanca el fitxer inicial y obre o crea un nou.
		 * @param lugar Direccio relativa del fitxer.
		 * @return false si es produeix algn error. 
		 * @throws FileNotFoundException Si es produeix un error al crear el nou fitxer.
		 */
		public boolean crea(String lugar) throws FileNotFoundException{
			if(this.esc!=null){//Si es nulo ya esta cerrado.
				if(this.cierra()){
					this.esc = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(lugar)));
					return true;
				}
			}else{
				this.esc = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(lugar)));
				return true;
			}
			return false;
		}
	 
		/**
		 * Tanca el fitxer obert.
		 * @return true Si es tanca correctament. 
		 */
		public boolean cierra(){
			try{//Intento borrar el esc
				if(this.esc != null){
					this.esc.close();
					this.esc = null;
				}
				return true;
			}catch(IOException ficCloseAnt){//Si falla lo pongo a nulo.
				return false;
			}
		}
	 
	 

}
