



 
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
 
/**
 * Clase per la llegir fitxers
 *  * @author Luis i Manel
 * 
 */
public class llegirfitxer {
 
	private BufferedReader lee;
	/**
	 * Constructor de llegirditxer
	 * @param lugar
	 * @throws FileNotFoundException
	 */
	public llegirfitxer(String lugar) throws FileNotFoundException{
		this.lee = new BufferedReader(new InputStreamReader(new FileInputStream(lugar)));
	}
 
	/**
	 * @return El fitxer sencer per linies.
	 */
	public String[] getLineas(){
		ArrayList<String> ar = new ArrayList<String>();
		String temp = this.leeLinea();
		while(temp!=null){
			ar.add(temp);
		}
		if(ar.size()<=0){
			return null;
		}
		return (String[])ar.toArray();
	}
 
	/**
	 * @return Una linia del fitxer.
	 */
	public String leeLinea(){
		try{
			return this.lee.readLine(); 
		}catch(IOException noExisteFich){
			return null;
		}
	}
 
	/**
	 * @return El caracter llegit, un enter entre 0 i 65535 (0x00-0xffff), o -1 si esta al final del fitxer.
	 * @throws IOException Si es produiex un error d'entrada o de sortida
	 */
	public int getChar() throws IOException{
		
			return this.lee.read();
	}
 
	/**
	 * Tanca el fitxer inicial(el creado en el constructor) y abre o crea uno nuevo.
	 * @param lugar ruta del fitxer.
	 * @return false si es produeix algn error. 
	 * @throws FileNotFoundException Si es produeix un error al crear un nou fitxer.
	 */
	public boolean abre(String lugar) throws FileNotFoundException{
		if(this.lee!=null){
			if(this.cierra()){
				this.lee = new BufferedReader(new InputStreamReader(new FileInputStream(lugar)));
				return true;
			}
			return false;
		}else{
			this.lee = new BufferedReader(new InputStreamReader(new FileInputStream(lugar)));
			return true;
		}
	}
 
	/**
	 * Tanca el fitxer obert actualmente.
	 * @return true Si ees tanca correctament.
	 */
	public boolean cierra(){
		if(this.lee != null){
			try {
				this.lee.close();
				this.lee=null;
				return true;
			} catch (IOException error) {
				return false;
			}
		}
		return true;
	}
}