import java.util.LinkedList;

/**
 * Clase node que implementa els threads i va enviant els missatges entre ells 
 * 
 * @author LUIS
 *
 */

public class node extends Thread{
		public int idnode;
		public LinkedList<missatge> buffer;
		private LinkedList<Integer> veinss =  new LinkedList<Integer>();
		private int [][] matriu;
		private dades d;
		private int mis_origen=0;
		private int mis_desti=0;
		private int mis_intermediari=0;
		private int rang=0;
		
		/** Construcitor de la clase node *
		 * 
		 * */
		public node(int idnode, int[][] matriu,dades d) {
			super();
			this.idnode = idnode;
			this.matriu = matriu;
			this.d=d;
			this.buffer= new LinkedList<missatge>();
		}
		/** Funcio que incrementa missatges rebuts actualitza distancia mitjana i les progresBar 
		 * 
		 * **/
		private void incrementar_mis_rebuts(missatge m){

			d.setMis_rebuts(d.getMis_rebuts()+1);
			float distancia1=m.getDistancia();
			d.distancia_mitjana_anterior=d.distancia_mitjana_anterior+distancia1;
			float mis_rebu=(float)d.getMis_rebuts();
			String dist_mit= new String("");
			d.setDistancia_mitjana((d.getDistancia_mitjana_anterior())/mis_rebu);
			dist_mit=(dist_mit+d.getDistancia_mitjana());
			d.jLabel10.setText(dist_mit);
			int mis_reb=d.getMis_rebuts();
			d.setMis_circulants(d.getNum_missatges()-mis_reb);
			String mis_circul=new String();
			mis_circul=mis_circul+d.getMis_circulants();
			d.jLabel6.setText(mis_circul);
			int progres= calcul_Progresbar();
			String progress= new String();
			progress=progress+progres + "%";
			d.jProgressBar.setValue(progres);
			d.jProgressBar.setString(progress);
		}
		
		/** Funcio que realitza el calcul en porcentage de la progresbar 
		 * 
		 *  return : int
		 *  
		 * **/
		private int calcul_Progresbar() {
			int progres=0;
			progres = ((d.getNum_missatges()-d.getMis_rebuts())*100)/d.getNum_missatges();
			progres = 100-progres;
			return progres;
		}
		
		/** Funcio que desapila el primer missatge del buffer del node
		 * 
		 *  return : missatge
		 *  
		 *  */
		public missatge desapila(){
			missatge i= buffer.getFirst();
			buffer.removeFirst();
			return i;
		}
		
		/** Funcio que afegeix un missatge al buffer del node fent servir syncrhonized
		 * 
		 *  **/
		public synchronized void add(missatge x){
			buffer.add(x);
			notifyAll();
		}
		
		/** Funcio que te el cos del tread (el que fa)
		 * 
		 * **/
		@SuppressWarnings("deprecation")
		public void run(){
			int idnodemostrar=idnode+1;
			/* plenem la taula de veins de cada node */
			for (int j=0; j<d.num_nodes; j++){
				if (matriu[idnode][j]==1){
					veinss.add(j);
					rang++;
				}
			}		
			/* comena protocol randomwalk */
			if (d.protocol=="randomwalk"){
				/* condicio inicial (miss_rebuts!=num_misstages) */
				while (d.mis_rebuts!=d.num_missatges){	
					try {
						sleep(0,1);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
					missatge m= new missatge(0, 0, "instancia nulla");
					boolean no_intermediari=false;
						/* Anem desapilant missatges */
						if (buffer.size()>0){
							m= (missatge) desapila();
							    /* Si font = identificador node incrementem mis_origen */
								if (m.getFont()==idnode+1){
									/*Si no ha contat com a origen conta com intermediari*/
									if (m.isHepasat()==false){
										mis_origen++;
										m.setHepasat(true);
									}
									no_intermediari=true;
								}
							/* Si node desti = identificador d'aquest node */
							if (m.getDesti()-1==idnode) {
								System.out.println("NODE " + idnodemostrar + " he rebut un missatge i soc el desti") ;
								/* Actualitzem Distancia maxima*/
								int distancia=0;
								distancia=m.getDistancia();
								if (distancia>d.getDistancia_max()){
									d.setDistancia_max(distancia);
									String dist_max= new String();
									dist_max=dist_max+d.getDistancia_max();
									d.jLabel8.setText(dist_max);
								}
								/* Cridem incrementar missatges rebuts */
								incrementar_mis_rebuts(m);
								/* Incrementem els missatges com a desti */
								mis_desti++;
							/* Si identificador node !=  missatge desti fem */		
							}else{
								/* Si no ha contat com a origen incrementem mis com a intermediari */
								if(no_intermediari==false){
									mis_intermediari++;
								}
								/* Fem math random i enviem missatge a un altre node */
								int r= veinss.size();
								int h = new Double(Math.random() * r).intValue();
								int q = veinss.get(h)+1;
								m.setDistancia(m.getDistancia()+1);
								d.n.get(veinss.get(h)).add(m);
								System.out.println("Jo node "+ idnodemostrar +" envio " + m.getMissatge() + " al node " + q);
							}
						}//fi if size>0
				}//fi while
				/* Guardem resultats a les atules de resultats */
				resultat res= new resultat(rang,mis_origen,mis_intermediari,mis_desti,idnodemostrar);
				d.addResultats(res);
				d.jButton3.setEnabled(true);
				System.out.println("---------------------------------------------");
				System.out.println("TOTS ELS MISSATGES SAN ENVIAT CORRECTAMENT");
				System.out.println("THREAD " + idnodemostrar +" ME DESTRUIT CORRECTAMENT");
				this.stop();
			/*fi if randomwalk*/
			}	
			/* Cos del protocol inteligent */
			if (d.protocol=="inteligent"){
				/* condicio inicial (miss_rebuts!=num_misstages) */
				while (d.mis_rebuts!=d.num_missatges){	
					try {
						sleep(0,1);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					missatge m= new missatge(0, 0, "instancia nulla");
					boolean no_intermediari=false;
					if (buffer.size()>0){
						synchronized (buffer){
							/* Anem desapilant missatges */
							m= (missatge) desapila();
						}//fi sincronized
							/* Si font = identificador node incrementem mis_origen */
							if (m.getFont()==idnode+1){
								mis_origen++;
								no_intermediari=true;
							}
							/* Posem el identificador del primer node on estem llista recorregut */
							m.addRecorregut(idnode);
							/* Si node desti = identificador d'aquest node */
							if (m.getDesti()-1==idnode) {
								System.out.println("NODE " + idnodemostrar + " he rebut un missatge i soc el desti") ;
									int distancia=0;
									/* Actualitzem Distancia maxima*/
									distancia=m.getDistancia();
									if (distancia>d.getDistancia_max()){
										d.setDistancia_max(distancia);
										String dist_max= new String();
										dist_max=dist_max+d.getDistancia_max();
										d.jLabel8.setText(dist_max);
									}
									/* Cridem incrementar missatges rebuts */
									incrementar_mis_rebuts(m);
									/* Incrementem els missatges com a desti */
									mis_desti++;
							/* Si identificador node !=  missatge desti fem */
							}else{
								/*si no som el desti ens agreguem a la llista recorregut*/
								m.addRecorregut(idnode);
								int max=0;
								int i=0;
								int j=0;
								boolean trobat=false;
								/* si node vei es el desti enviem */
								while(trobat==false && i<veinss.size()){
									if (veinss.get(i)==m.getDesti()-1){
										m.setDistancia(m.getDistancia()+1);
										d.n.get(veinss.get(i)).add(m);
										trobat=true;
										j=veinss.get(i);
										j++;
										System.out.println("Jo node "+ idnodemostrar +" envio " + m.getMissatge() + " al node " + j);
									}
									i++;
								}
								i=0;
								j=0;
								/* si node vei no es desti enviem missatge al node vei amb mes arestes */
								while(trobat==false && i<=veinss.size()){
									if (i>=veinss.size()){
										/* Si ja no queden nodes_veins per enviar (Problema d'algun tipus de xarxes fem math random fins que poguem sortir del problema)*/
										if (max==0){
											int r= veinss.size();
											int h = new Double(Math.random() * r).intValue();
											int q = veinss.get(h)+1;
											m.setDistancia(m.getDistancia()+1);
											d.n.get(veinss.get(h)).add(m);
											trobat=true;
											System.out.println("Jo node "+ idnodemostrar +" envio " + m.getMissatge() + " al node " + q);
										/* Sino enviem al node amb grau mes gran */
										}else{
											m.setDistancia(m.getDistancia()+1);	
											d.n.get(j).add(m);
											j++;
											System.out.println("Jo node "+ idnodemostrar +" envio " + m.getMissatge() + " al node " + j);			
											trobat=true;
										}
									/* Mirem quin es el node amb grau mes gran */										
									}else{
										if (i<veinss.size()||max<d.n.get(veinss.get(i)).veinss.size()){
											/*si j no esta a la taula de recorregut max=j sino re. */
											if (!(m.getRecorregut().contains(veinss.get(i)))){
												max=d.n.get(veinss.get(i)).veinss.size();
												j=veinss.get(i);
											}
											i++;
										}
									}
								
								}//acaba while
								if (no_intermediari==false){
									/* Incrementem missatges com a intermediari */
									mis_intermediari++;
								}
							}
						}//fi if size>0
				}//fi while
				/*Guardem resultats a la taula de resultats */
				resultat res= new resultat(rang,mis_origen,mis_intermediari,mis_desti,idnodemostrar);
				d.resultats.add(res);
				d.jButton3.setEnabled(true);
				System.out.println("---------------------------------------------");
				System.out.println("TOTS ELS MISSATGES SAN ENVIAT CORRECTAMENT");
				System.out.println("THREAD " + idnodemostrar +" ME DESTRUIT CORRECTAMENT");
				this.stop();
			}
			
		}
	
	}
